import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { MultiSliderThumbRangePosition_$type } from "./MultiSliderThumbRangePosition";
import { IgrMultiSliderTrackThumbRange } from "./igr-multi-slider-track-thumb-range";
import { IgrPropertyUpdatedEventArgs } from "igniteui-react-core";
import { MultiSliderThumb as MultiSliderThumb_internal } from "./MultiSliderThumb";
import { ensureEnum } from "igniteui-react-core";
export class IgrMultiSliderThumb {
    createImplementation() {
        return new MultiSliderThumb_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._propertyUpdated = null;
        this._propertyUpdated_wrapped = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get value() {
        return this.i.s;
    }
    set value(v) {
        this.i.s = +v;
    }
    get rangePosition() {
        return this.i.g;
    }
    set rangePosition(v) {
        this.i.g = ensureEnum(MultiSliderThumbRangePosition_$type, v);
    }
    get range() {
        const r = this.i.i;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrMultiSliderTrackThumbRange();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set range(v) {
        v == null ? this.i.i = null : this.i.i = v.i;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.range && this.range.name && this.range.name == name) {
            return this.range;
        }
        return null;
    }
    push(amount) {
        let iv = this.i.r(amount);
        return (iv);
    }
    get propertyUpdated() {
        return this._propertyUpdated;
    }
    set propertyUpdated(ev) {
        if (this._propertyUpdated_wrapped !== null) {
            this.i.propertyUpdated = delegateRemove(this.i.propertyUpdated, this._propertyUpdated_wrapped);
            this._propertyUpdated_wrapped = null;
            this._propertyUpdated = null;
        }
        this._propertyUpdated = ev;
        this._propertyUpdated_wrapped = (o, e) => {
            let outerArgs = new IgrPropertyUpdatedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforePropertyUpdated) {
                this.beforePropertyUpdated(this, outerArgs);
            }
            if (this._propertyUpdated) {
                this._propertyUpdated(this, outerArgs);
            }
        };
        this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, this._propertyUpdated_wrapped);
        ;
    }
}
