import { IgrMultiSliderThumb } from "./igr-multi-slider-thumb";
import { MultiSliderTrackThumbRange as MultiSliderTrackThumbRange_internal } from "./MultiSliderTrackThumbRange";
export class IgrMultiSliderTrackThumbRange {
    createImplementation() {
        return new MultiSliderTrackThumbRange_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get position() {
        return this.i.n;
    }
    set position(v) {
        this.i.n = +v;
    }
    get width() {
        return this.i.r;
    }
    set width(v) {
        this.i.r = +v;
    }
    get minWidth() {
        return this.i.m;
    }
    set minWidth(v) {
        this.i.m = +v;
    }
    get maxWidth() {
        return this.i.l;
    }
    set maxWidth(v) {
        this.i.l = +v;
    }
    get lowerThumb() {
        const r = this.i.f;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrMultiSliderThumb();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set lowerThumb(v) {
        v == null ? this.i.f = null : this.i.f = v.i;
    }
    get higherThumb() {
        const r = this.i.e;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrMultiSliderThumb();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set higherThumb(v) {
        v == null ? this.i.e = null : this.i.e = v.i;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.lowerThumb && this.lowerThumb.name && this.lowerThumb.name == name) {
            return this.lowerThumb;
        }
        if (this.higherThumb && this.higherThumb.name && this.higherThumb.name == name) {
            return this.higherThumb;
        }
        return null;
    }
}
