import { IgrMultiSliderThumb } from "./igr-multi-slider-thumb";
import { MultiSliderTrackThumbRange as MultiSliderTrackThumbRange_internal } from "./MultiSliderTrackThumbRange";
var IgrMultiSliderTrackThumbRange = /** @class */ /*@__PURE__*/ (function () {
    function IgrMultiSliderTrackThumbRange() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrMultiSliderTrackThumbRange.prototype.createImplementation = function () {
        return new MultiSliderTrackThumbRange_internal();
    };
    Object.defineProperty(IgrMultiSliderTrackThumbRange.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrMultiSliderTrackThumbRange.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrMultiSliderTrackThumbRange.prototype.onImplementationCreated = function () {
    };
    IgrMultiSliderTrackThumbRange.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrMultiSliderTrackThumbRange.prototype, "position", {
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrMultiSliderTrackThumbRange.prototype, "width", {
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrMultiSliderTrackThumbRange.prototype, "minWidth", {
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrMultiSliderTrackThumbRange.prototype, "maxWidth", {
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrMultiSliderTrackThumbRange.prototype, "lowerThumb", {
        get: function () {
            var r = this.i.f;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrMultiSliderThumb();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.f = null : this.i.f = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrMultiSliderTrackThumbRange.prototype, "higherThumb", {
        get: function () {
            var r = this.i.e;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrMultiSliderThumb();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.e = null : this.i.e = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrMultiSliderTrackThumbRange.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.lowerThumb && this.lowerThumb.name && this.lowerThumb.name == name) {
            return this.lowerThumb;
        }
        if (this.higherThumb && this.higherThumb.name && this.higherThumb.name == name) {
            return this.higherThumb;
        }
        return null;
    };
    return IgrMultiSliderTrackThumbRange;
}());
export { IgrMultiSliderTrackThumbRange };
