import * as React from 'react';
import { ColorEditorPanel } from "./ColorEditorPanel";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { IgrColorEditorPanelSelectedValueChangedEventArgs } from "./igr-color-editor-panel-selected-value-changed-event-args";
export declare class IgrColorEditorPanel extends React.Component<IIgrColorEditorPanelProps> {
    private _container;
    private _initialized;
    private _elRef;
    private _portalManager;
    private _wrapper;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    private requestRender;
    constructor(props: IIgrColorEditorPanelProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): ColorEditorPanel;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ColorEditorPanel; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrColorEditorPanel;
    private _colorEditorPanel;
    /**
 * Gets or Sets the value for the color editor panel.
*/
    get value(): string;
    set value(v: string);
    /**
     * Gets or sets the display density to use for the ColorEditorPanel.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets or sets the base built in theme to use for the ColorEditorPanel.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or Sets the selected color background color
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or Sets the selected color boreder color
    */
    get selectedColorBorderColor(): string;
    set selectedColorBorderColor(v: string);
    /**
     * Gets or Sets the selected color border color
    */
    get selectedFocusDateBackgroundColor(): string;
    set selectedFocusDateBackgroundColor(v: string);
    /**
     * Gets or Sets the focus color border color
    */
    get focusColorBorderColor(): string;
    set focusColorBorderColor(v: string);
    /**
     * Gets or Sets the focus date background color
    */
    get hoverBackgroundColor(): string;
    set hoverBackgroundColor(v: string);
    /**
     * Gets or Sets the selected date text color
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the font to use for the combobox.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio(): number;
    set pixelScalingRatio(v: number);
    get actualPixelScalingRatio(): number;
    set actualPixelScalingRatio(v: number);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    private _valueChanged;
    private _valueChanged_wrapped;
    /**
     * Called when date is selected.
    */
    get valueChanged(): (s: IgrColorEditorPanel, e: IgrColorEditorPanelSelectedValueChangedEventArgs) => void;
    set valueChanged(ev: (s: IgrColorEditorPanel, e: IgrColorEditorPanelSelectedValueChangedEventArgs) => void);
    private _valueChanging;
    private _valueChanging_wrapped;
    /**
     * Called when date is selected.
    */
    get valueChanging(): (s: IgrColorEditorPanel, e: IgrColorEditorPanelSelectedValueChangedEventArgs) => void;
    set valueChanging(ev: (s: IgrColorEditorPanel, e: IgrColorEditorPanelSelectedValueChangedEventArgs) => void);
}
export interface IIgrColorEditorPanelProps {
    children?: React.ReactNode;
    /**
 * Gets or Sets the value for the color editor panel.
*/
    value?: string;
    /**
     * Gets or sets the display density to use for the ColorEditorPanel.
    */
    density?: ControlDisplayDensity | string;
    /**
     * Gets or sets the base built in theme to use for the ColorEditorPanel.
    */
    baseTheme?: BaseControlTheme | string;
    /**
     * Gets or Sets the selected color background color
    */
    backgroundColor?: string;
    /**
     * Gets or Sets the selected color boreder color
    */
    selectedColorBorderColor?: string;
    /**
     * Gets or Sets the selected color border color
    */
    selectedFocusDateBackgroundColor?: string;
    /**
     * Gets or Sets the focus color border color
    */
    focusColorBorderColor?: string;
    /**
     * Gets or Sets the focus date background color
    */
    hoverBackgroundColor?: string;
    /**
     * Gets or Sets the selected date text color
    */
    textColor?: string;
    /**
     * Gets or sets the font to use for the combobox.
    */
    textStyle?: string;
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    pixelScalingRatio?: number | string;
    actualPixelScalingRatio?: number | string;
    /**
 * Called when date is selected.
*/
    valueChanged?: (s: IgrColorEditorPanel, e: IgrColorEditorPanelSelectedValueChangedEventArgs) => void;
    /**
     * Called when date is selected.
    */
    valueChanging?: (s: IgrColorEditorPanel, e: IgrColorEditorPanelSelectedValueChangedEventArgs) => void;
}
